%define name speech_tools
%define version 1.2.3
%define release 1mdk
%define festival_ver 1.4.3
%define major 1
%define libname %mklibname %name %major
%define libnamedevel %mklibname %name %major -d
%global shared 0
%if !%shared
%define libnamedevel %libname-static-devel
%endif


Name:  		%{name}
Summary: 	A free speech synthesizer 
Version: 	%{version}
Release: 	%{release}
License: 	BSD
Group: 		Sound
URL: 		http://www.cstr.ed.ac.uk/projects/festival/
Source: 	ftp://ftp.cstr.ed.ac.uk/pub/festival/%{festival_ver}/speech_tools-%{version}-release.tar.bz2
Source3: 	speech_tools-config
BuildRoot: 	%{_tmppath}/%{name}-%{version}-root 
BuildRequires: 	%_bindir/readlink
BuildRequires: 	libtermcap-devel
Patch0:         %{name}-termcap.patch.bz2
Patch1:         %{name}-shared.patch.bz2

# Translate this strange pseudocode to real C++
Patch20: speech_tools-1.2.2-c++.patch.bz2

%description
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

%if %shared
%package -n %{libname}
Summary:  	Static libraries and headers for festival text to speech
Group: 		System/Libraries
Requires: 	%{name} = %{version}-%release

%description -n %{libname}
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

This package contains the libraries and includes files necessary for
applications that use festival.
%endif

%package 	-n %{libnamedevel}
Summary:  	Static libraries and headers for festival text to speech
Group: 		Development/C++
Requires: 	%{name} = %{version}-%release
Provides:	%{name}-devel

%description -n %{libnamedevel}
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

This package contains the libraries and includes files necessary to develop
applications using festival.
 
%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n %{name}
#%patch -p1
%if %shared
%patch1 -p1
%endif

%build
%configure
%make

%install
rm -Rf %{buildroot}
mkdir -p $RPM_BUILD_ROOT/{%{_bindir},%{_libdir},%{_includedir}/EST,%{_datadir}/%{name}/example_data,%{_libdir}/%{name}/{scripts,siod,stats/wagon,grammar/{scfg,wfst}}}

rm -f $RPM_BUILD_ROOT%_bindir/Makefile

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1

# includes
cp -a include/* $RPM_BUILD_ROOT%{_includedir}/EST
find $RPM_BUILD_ROOT%{_includedir}/EST -name Makefile -exec rm \{\} \;
for file in `find $RPM_BUILD_ROOT%{_includedir}/EST -type f`
do
        sed 's/\"\(.*h\)\"/\<EST\/\1\>/g' $file > $file.tmp
	mv $file.tmp $file
done
sed 's/\<EST\//&rxp\//g' $RPM_BUILD_ROOT%{_includedir}/EST/rxp/rxp.h > bzzz
mv bzzz $RPM_BUILD_ROOT%{_includedir}/EST/rxp/rxp.h
for i in $RPM_BUILD_ROOT%{_includedir}/EST/rxp/*
do
	ln -s %{_includedir}/EST/rxp/`basename $i` $RPM_BUILD_ROOT%{_includedir}/EST/`basename $i`
done
ln -s %{_includedir}/EST $RPM_BUILD_ROOT%{_libdir}/%{name}/include

# libraries
install lib/lib* $RPM_BUILD_ROOT%{_libdir}
%if %shared
for i in $RPM_BUILD_ROOT%{_libdir}/*.so
do
        rm $i
	ln -s `basename $i*` $i
done
%endif
		
# binaries
install `find bin -type f -perm +1` $RPM_BUILD_ROOT%{_bindir}

# scripts
install scripts/{example_to_doc++.prl,make_wagon_desc.sh,resynth.sh,shared_script,shared_setup_prl,shared_setup_sh} \
	$RPM_BUILD_ROOT%{_libdir}/%{name}/scripts

# example data
install lib/example_data/* $RPM_BUILD_ROOT%{_datadir}/%{name}/example_data
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/example_data/Makefile

cp -a config $RPM_BUILD_ROOT/%{_libdir}/speech_tools
cp -r testsuite $RPM_BUILD_ROOT%{_libdir}/%{name}
rm $RPM_BUILD_ROOT%{_libdir}/%{name}/testsuite/*.o
install siod/siod.mak $RPM_BUILD_ROOT%{_libdir}/%{name}/siod
install lib/siod/*.scm $RPM_BUILD_ROOT%{_libdir}/%{name}/siod
install stats/ols.mak $RPM_BUILD_ROOT%{_libdir}/%{name}/stats
install stats/wagon/wagon.mak $RPM_BUILD_ROOT%{_libdir}/%{name}/stats/wagon
install grammar/scfg/scfg.mak $RPM_BUILD_ROOT%{_libdir}/%{name}/grammar/scfg
install grammar/wfst/wfst.mak $RPM_BUILD_ROOT%{_libdir}/%{name}/grammar/wfst


# symlinks into buildtree evil
for i in $RPM_BUILD_ROOT%_bindir/*; do
	if [ -h "$i" ]; then
    		a=`readlink "$i"`
		rm -f "$i"	
		cp -a "$a" $RPM_BUILD_ROOT%_bindir/
	fi
done


# Remove some files we don't need
rm -rf $RPM_BUILD_ROOT%_includedir/speech_tools/win32
rm -f  $RPM_BUILD_ROOT%_datadir/festival/etc/unknown_RedHatLinux/

find $RPM_BUILD_ROOT -type f -size 0 -exec rm -f {} \;

%clean
rm -rf $RPM_BUILD_ROOT

%if %shared
%post -n %{libname} 
/sbin/ldconfig

%postun -n %{libname}
/sbin/ldconfig
%endif

%files
%defattr(-,root,root)
%doc INSTALL README
%{_bindir}/*
%{_datadir}/%{name}


%if %shared
%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*
%endif

%files -n %{libnamedevel}
%defattr(-,root,root)
%_includedir/EST
%{_libdir}/%{name}
%if %shared
%{_libdir}/*.so
%else
%_libdir/*.a
%endif

#%files -n %{libname}-static-devel
#%defattr(-,root,root)
#%_libdir/*.a

%changelog
* Tue Feb 11 2003 Buchan Milne <bgmilne@linux-mandrake.com> 1.2.3-1mdk
- PLF->MDK (satisfy requires in speaker3 ;-))
- Split voices into seperate srpm (make them noarch)
- Split off speech_tools from festival
- Cleanups and unpackaged files

* Sun Sep  8 2002 Gtz Waschk <waschk@informatik.uni-rostock.de> 1.4.2-3plf
- update patch 20 and 21 to the rawhide versions -> gcc 3.2 build 

* Fri Jul 26 2002 Gtz Waschk <waschk@informatik.uni-rostock.de> 1.4.2-2plf
- gcc 3.2 build

* Fri Jul  5 2002 Gtz Waschk <waschk@informatik.uni-rostock.de> 1.4.2-1plf
- fixed buildrequires (readlink, termcap)
- adapted spec from Charles A Edwards <eslrahc@bellsouth.net>

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Jun 10 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.4.2-7
- Fix some rpmlint errors

* Mon Jun 10 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.4.2-6
- Fix ISO C++ compliance

* Mon Mar 18 2002 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Mar 14 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.4.2-2
- Get rid of CVS directiories in doc dir
- Fix broken symlinks for components from speech_tools

* Wed Mar  6 2002 Trond Eivind Glomsrd <teg@redhat.com>
- 1.4.2
- Lots of fixes to make it build, more needed
- Cleanups
- Update URL
- Fix docs inclusion
- Drop prefix
- Use %%{_tmppath}

* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add defattr (Bug #15033)

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Mon Jul 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Thu Jul  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- FHSify

* Mon Jun 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on non-x86

* Sun Apr 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- initial packaging
